Public Class Form1
    Public Const div_y = 8
    Public Const div_x = 10
    Public Const box_delta_y = 40
    Public Const box_delta_x = 40

    Public Const MAX_DATA = 1250
    Public Const MAX_DATA_VALUE = 894

    Dim RX_Data(MAX_DATA + 1) As Integer
    Dim RX_max_Data(MAX_DATA + 1) As Integer
    Dim RX_max_Data_counter(MAX_DATA + 1) As Integer

    Dim Byte_RX_Count As Integer

    Dim hold_max As Integer = 0

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim ports() As String
        Dim port As String

        Write_Spectrum()
        Timer1.Start()

        'Com Ports suchen und in Liste eintragen
        ports = System.IO.Ports.SerialPort.GetPortNames
        ComboBox1.Text = ports(0)
        For Each port In ports
            ComboBox1.Items.Add(port)
        Next port

        ComboBox1.SelectedIndex() = 0
        SerialPort1.PortName() = ComboBox1.Items.IndexOf(1)
        ComboBox2.SelectedIndex() = 0

    End Sub
    Private Sub Write_Spectrum()

        Dim myGrafik As Graphics
        Dim myPen1 As New Pen(Color.Yellow, 1)
        Dim myPen4 As New Pen(Color.Red, 1)
        Dim myPen2 As New Pen(Color.LightGray, 1)
        Dim myPen3 As New Pen(Color.LightGray, 2)
        Dim count As Integer
        Dim attenuator As Decimal

        Dim pb_x As Integer
        Dim pb_y As Integer

        Dim delta_y As Decimal
        Dim delta_x As Decimal

        Dim delta_y1 As Decimal
        Dim delta_x1 As Decimal

        Dim Scanwidth As Decimal
        Dim Center_Frequenz As Decimal

        Dim grafx As BufferedGraphics
        Dim context As BufferedGraphicsContext

        Dim Scale As Decimal
        Dim text_sise As Byte
        text_sise = 9
        Dim f As Font = New Font("Arial", text_sise)
        Dim text As String = "  "

        context = BufferedGraphicsManager.Current
        context.MaximumBuffer = New Size(PictureBox1.Width + 1, PictureBox1.Height + 1)
        grafx = context.Allocate(PictureBox1.CreateGraphics(), New Rectangle(0, 0, PictureBox1.Width, PictureBox1.Height))

        'clear buffer
        grafx.Graphics.FillRectangle(Brushes.Black, 0, 0, PictureBox1.Width, PictureBox1.Height)

        myGrafik = Graphics.FromHwnd(hwnd:=PictureBox1().Handle)

        pb_x = PictureBox1.Width - (2 * box_delta_x)
        pb_y = PictureBox1.Height - (2 * box_delta_y)

        delta_y = pb_y / div_y
        delta_x = pb_x / div_x

        delta_y1 = pb_y / MAX_DATA_VALUE
        delta_x1 = pb_x / MAX_DATA 'RX_DATA
        'paint horizontal lines
        For count = 0 To div_y
            If count = 4 Then
                grafx.Graphics.DrawLine(myPen2, box_delta_x, (delta_y * count) + box_delta_y, pb_x + box_delta_x, (delta_y * count) + box_delta_y)
            Else
                grafx.Graphics.DrawLine(myPen2, box_delta_x, (delta_y * count) + box_delta_y, pb_x + box_delta_x, (delta_y * count) + box_delta_y)
            End If
        Next

        'paint vertical lines
        For count = 0 To div_x
            If count = 5 Then
                grafx.Graphics.DrawLine(myPen3, (delta_x * count) + box_delta_x, box_delta_y, (delta_x * count) + box_delta_x, pb_y + box_delta_y)
            Else
                grafx.Graphics.DrawLine(myPen2, (delta_x * count) + box_delta_x, box_delta_y, (delta_x * count) + box_delta_x, pb_y + box_delta_y)
            End If
        Next


        For count = 1 To (MAX_DATA - 2) 'RX_DATA
            'paint data line
            grafx.Graphics.DrawLine(myPen1, ((count) * delta_x1) - delta_x1 + box_delta_x, (MAX_DATA_VALUE - RX_Data(count)) * delta_y1 + box_delta_y, (count * delta_x1) + box_delta_x, (MAX_DATA_VALUE - RX_Data(count + 1)) * delta_y1 + box_delta_y)
            If hold_max = 1 Then
                'paint data line max
                grafx.Graphics.DrawLine(myPen4, ((count) * delta_x1) - delta_x1 + box_delta_x, (MAX_DATA_VALUE - RX_max_Data(count)) * delta_y1 + box_delta_y, (count * delta_x1) + box_delta_x, (MAX_DATA_VALUE - RX_max_Data(count + 1)) * delta_y1 + box_delta_y)
            End If
        Next

        '******************** Print Text *******************

        grafx.Graphics.DrawString(TimeString + text + DateString, f, Brushes.White, pb_x - (10 * text_sise), (box_delta_y / 2))

        grafx.Graphics.DrawString("dBm", f, Brushes.White, (box_delta_x / 4), (box_delta_y / 2))

        attenuator = 0
        If CheckBox1.Checked Then
            attenuator = attenuator + 10
        End If
        If CheckBox3.Checked Then
            attenuator = attenuator + 20
        End If
        If CheckBox2.Checked Then
            attenuator = attenuator + 30
        End If
        If CheckBox4.Checked Then
            attenuator = attenuator + 40
        End If

        Scale = -27 + attenuator
        text = "Attenuator: "
        grafx.Graphics.DrawString(text + Str(attenuator), f, Brushes.White, box_delta_x - text_sise, pb_y + box_delta_y + text_sise + 5)

        'paint horizontal scale
        For count = 0 To div_y
            grafx.Graphics.DrawString(Str(Scale), f, Brushes.LightGray, (box_delta_x / 4), (delta_y * count) + (box_delta_y - text_sise))
            Scale = Scale - 10
        Next

        grafx.Graphics.DrawString("MHz", f, Brushes.White, pb_x + box_delta_x - text_sise, pb_y + box_delta_y + text_sise + 5)

        If ComboBox2.Text = "100 MHz" Then Scanwidth = 100
        If ComboBox2.Text = "50 MHz" Then Scanwidth = 50
        If ComboBox2.Text = "20 MHz" Then Scanwidth = 20
        If ComboBox2.Text = "10 MHz" Then Scanwidth = 10
        If ComboBox2.Text = "5 MHz" Then Scanwidth = 5
        If ComboBox2.Text = "2 MHz" Then Scanwidth = 2
        If ComboBox2.Text = "1 MHz" Then Scanwidth = 1
        If ComboBox2.Text = "0.5 MHz" Then Scanwidth = 0.5
        If ComboBox2.Text = "0.2 MHz" Then Scanwidth = 0.2
        If ComboBox2.Text = "0.1 MHz" Then Scanwidth = 0.1

        If TextBox1.Text = "" Or TextBox1.Text = "," Then
            Center_Frequenz = 0
        Else
            Center_Frequenz = CType(TextBox1.Text, Decimal)
        End If
        Scale = Center_Frequenz - (div_x / 2 * Scanwidth)

        'paint vertical scale
        For count = 0 To div_x
            grafx.Graphics.DrawString(Str(Scale), f, Brushes.LightGray, (delta_x * count) + box_delta_x - text_sise, pb_y + box_delta_y)
            Scale = Scale + Scanwidth
        Next

        'display buffer
        grafx.Render(myGrafik)

    End Sub
    Private Sub Form1_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.SizeChanged
        Write_Spectrum()
    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Write_Spectrum()
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        'Button COM Port Open/Close
        If SerialPort1.IsOpen = False Then
            Button6.Text = "CLOSE"
            Button6.BackColor = SystemColors.Control
            ComboBox1.Enabled = False
            Byte_RX_Count = MAX_DATA
            SerialPort1.Open()
        Else
            Button6.Text = "OPEN"
            ComboBox1.Enabled = True
            Button6.BackColor = Color.Red
            SerialPort1.Close()
        End If
    End Sub

    Private Sub GroupBox1_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GroupBox1.Enter

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If PrintDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            PrintDocument1.Print()
        End If
    End Sub

    Private Sub PrintDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage
        Dim grafx As Graphics = e.Graphics
        Dim myPen1 As New Pen(Color.Black, 1)
        Dim myPen2 As New Pen(Color.DarkGray, 1)
        Dim myPen3 As New Pen(Color.DarkGray, 1)
        Dim myPen4 As New Pen(Color.Red, 1)
        Dim count As Integer
        Dim attenuator As Decimal
        Dim Center_Frequenz As Decimal

        Dim Scanwidth As Decimal

        Dim pb_x As Integer
        Dim pb_y As Integer

        Dim delta_y As Decimal
        Dim delta_x As Decimal

        Dim delta_y1 As Decimal
        Dim delta_x1 As Decimal

        Dim Scale As Decimal
        Dim text_sise As Byte
        text_sise = 9
        Dim f As Font = New Font("Arial", text_sise)
        Dim text As String = "  "

        pb_x = 650 - (2 * box_delta_x)
        pb_y = 520 - (2 * box_delta_y)

        delta_y = pb_y / div_y
        delta_x = pb_x / div_x

        delta_y1 = pb_y / MAX_DATA_VALUE
        delta_x1 = pb_x / MAX_DATA 'RX_DATA
        'paint horizontal lines
        For count = 0 To div_y
            If count = 4 Then
                grafx.DrawLine(myPen2, box_delta_x, (delta_y * count) + box_delta_y, pb_x + box_delta_x, (delta_y * count) + box_delta_y)
            Else
                grafx.DrawLine(myPen2, box_delta_x, (delta_y * count) + box_delta_y, pb_x + box_delta_x, (delta_y * count) + box_delta_y)
            End If
        Next

        'paint vertical lines
        For count = 0 To div_x
            If count = 5 Then
                grafx.DrawLine(myPen3, (delta_x * count) + box_delta_x, box_delta_y, (delta_x * count) + box_delta_x, pb_y + box_delta_y)
            Else
                grafx.DrawLine(myPen2, (delta_x * count) + box_delta_x, box_delta_y, (delta_x * count) + box_delta_x, pb_y + box_delta_y)
            End If
        Next

        For count = 1 To (MAX_DATA - 2) 'RX_DATA
            'paint data line
            grafx.DrawLine(myPen1, ((count) * delta_x1) - delta_x1 + box_delta_x, (MAX_DATA_VALUE - RX_Data(count)) * delta_y1 + box_delta_y, (count * delta_x1) + box_delta_x, (MAX_DATA_VALUE - RX_Data(count + 1)) * delta_y1 + box_delta_y)
            If hold_max = 1 Then
                'paint data line max
                grafx.DrawLine(myPen4, ((count) * delta_x1) - delta_x1 + box_delta_x, (MAX_DATA_VALUE - RX_max_Data(count)) * delta_y1 + box_delta_y, (count * delta_x1) + box_delta_x, (MAX_DATA_VALUE - RX_max_Data(count + 1)) * delta_y1 + box_delta_y)
            End If
        Next

        '******************** Print Text *******************

        grafx.DrawString(TimeString + Text + DateString, f, Brushes.Black, pb_x - (10 * text_sise), (box_delta_y / 2))

        grafx.DrawString("dBm", f, Brushes.Black, (box_delta_x / 4), (box_delta_y / 2))
        attenuator = 0
        If CheckBox1.Checked Then
            attenuator = attenuator + 10
        End If
        If CheckBox3.Checked Then
            attenuator = attenuator + 20
        End If
        If CheckBox2.Checked Then
            attenuator = attenuator + 30
        End If
        If CheckBox4.Checked Then
            attenuator = attenuator + 40
        End If

        Scale = -27 + attenuator
        text = "Attenuator: "
        grafx.DrawString(text + Str(attenuator), f, Brushes.Black, box_delta_x - text_sise, pb_y + box_delta_y + text_sise + 5)

        'paint horizontal scale
        For count = 0 To div_y
            grafx.DrawString(Str(Scale), f, Brushes.Black, (box_delta_x / 4), (delta_y * count) + (box_delta_y - text_sise))
            Scale = Scale - 10
        Next

        grafx.DrawString("MHz", f, Brushes.Black, pb_x + box_delta_x - text_sise, pb_y + box_delta_y + text_sise + 2)

        If ComboBox2.Text = "100 MHz" Then Scanwidth = 100
        If ComboBox2.Text = "50 MHz" Then Scanwidth = 50
        If ComboBox2.Text = "20 MHz" Then Scanwidth = 20
        If ComboBox2.Text = "10 MHz" Then Scanwidth = 10
        If ComboBox2.Text = "5 MHz" Then Scanwidth = 5
        If ComboBox2.Text = "2 MHz" Then Scanwidth = 2
        If ComboBox2.Text = "1 MHz" Then Scanwidth = 1
        If ComboBox2.Text = "0.5 MHz" Then Scanwidth = 0.5
        If ComboBox2.Text = "0.2 MHz" Then Scanwidth = 0.2
        If ComboBox2.Text = "0.1 MHz" Then Scanwidth = 0.1

        If TextBox1.Text = "" Then
            Center_Frequenz = 0
        Else
            Center_Frequenz = CType(TextBox1.Text, Decimal)
        End If
        Scale = Center_Frequenz - (div_x / 2 * Scanwidth)

        'paint vertical scale
        For count = 0 To div_x
            grafx.DrawString(Str(Scale), f, Brushes.Black, (delta_x * count) + box_delta_x - text_sise, pb_y + box_delta_y)
            Scale = Scale + Scanwidth
        Next

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        PrintPreviewDialog1.Document = PrintDocument1
        If PrintPreviewDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            PrintDocument1.Print()
        End If
    End Sub

    Private Sub GroupBox2_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub TextBox1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox1.KeyPress
        Select Case Asc(e.KeyChar)
            Case 48 To 57, 44, 8, 32
                ' Zahlen, Backspace und Space zulassen

            Case Else
                ' alle anderen Eingaben unterdrcken
                e.Handled = True
        End Select
    End Sub

    Private Sub SerialPort1_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        Dim count As Integer
        Dim tmp As Integer
        If SerialPort1.IsOpen = True Then
            For count = 1 To (SerialPort1.BytesToRead \ 2)
                If Byte_RX_Count < MAX_DATA Then

                    If SerialPort1.IsOpen = True Then
                        tmp = SerialPort1.ReadByte()
                        If tmp = 255 Then
                            Byte_RX_Count = 0
                            Return
                        End If
                        tmp = tmp * 255
                        tmp = tmp + SerialPort1.ReadByte()
                        If tmp > 1024 Then
                            Byte_RX_Count = 0
                            tmp = SerialPort1.ReadByte()
                            Return
                        End If
                    End If

                    RX_Data(Byte_RX_Count) = tmp
                    If tmp > RX_max_Data(Byte_RX_Count) Then
                        RX_max_Data(Byte_RX_Count) = tmp
                    End If
                    Byte_RX_Count = Byte_RX_Count + 1
                Else
                    If SerialPort1.IsOpen = True Then
                        tmp = SerialPort1.ReadByte()
                        tmp = tmp * 255
                        tmp = tmp + SerialPort1.ReadByte()
                    End If

                    If (tmp > MAX_DATA_VALUE) Then
                        Byte_RX_Count = 0
                    End If
                End If

            Next
        End If
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        SerialPort1.PortName() = ComboBox1.Text
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim counter As Integer
        For counter = 0 To MAX_DATA
            RX_max_Data(counter) = 0
        Next
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim counter As Integer

        If hold_max = 1 Then
            hold_max = 0
        Else
            For counter = 0 To MAX_DATA
                RX_max_Data(counter) = 0
            Next
            hold_max = 1
        End If
    End Sub
End Class
